﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;


namespace WindowsFormsApp2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {

            ////////////////////////////////////////////////////
            ///


			
MFSDK sdk;
sdk = new MFSDK();
sdk.Iniciales.Add("MODOINI", "DIVISOR");
sdk.Iniciales.Add("RESPUESTA_UTF8", "SI");

		
sdk.Iniciales.Add("cfdi", "c:/sdk2/timbrados/ejemplo_factura_retenciones2_Pagosaextranjeros.xml");
sdk.Iniciales.Add("remueve_acentos", "SI");
sdk.Iniciales.Add("retencion", "SI");
sdk.Iniciales.Add("version_retencion", "2");
sdk.Iniciales.Add("php_openssl", "SI");
sdk.Iniciales.Add("xml_debug", "c:/sdk2/timbrados/ejemplo_factura_retenciones2_Pagosaextranjeros_debug.xml");



//#NODO [Pagosaextranjeros]
MFObject Pagosaextranjeros = new MFObject("Pagosaextranjeros");
Pagosaextranjeros["EsBenefEfectDelCobro"] = "NO";



//#NODO [Pagosaextranjeros/NoBeneficiario]
MFObject Pagosaextranjeros_NoBeneficiario = new MFObject("NoBeneficiario");
Pagosaextranjeros_NoBeneficiario["ConceptoPago"] = "1";
Pagosaextranjeros_NoBeneficiario["DescripcionConcepto"] = "Artistas, deportistas y espectÃÂ¡culos pÃÂºblicos";
Pagosaextranjeros_NoBeneficiario["PaisDeResidParaEfecFisc"] = "US";



//#NODO [Pagosaextranjeros/Beneficiario]
MFObject Pagosaextranjeros_Beneficiario = new MFObject("Beneficiario");
Pagosaextranjeros_Beneficiario["ConceptoPago"] = "1";
Pagosaextranjeros_Beneficiario["DescripcionConcepto"] = "Artistas, deportistas y espectÃÂ¡culos pÃÂºblicos";
Pagosaextranjeros_Beneficiario["NomDenRazSocB"] = "MIGUEL SOSA HERNANDEZ";
Pagosaextranjeros_Beneficiario["CURP"] = "SOHM831217HCCSRG06";
Pagosaextranjeros_Beneficiario["RFC"] = "SOHM831217K14";



//#NODO [periodo]
MFObject periodo = new MFObject("periodo");
periodo["MesIni"] = "01";
periodo["MesFin"] = "03";
periodo["Ejercicio"] = "2023";



//#NODO [emisor]
MFObject emisor = new MFObject("emisor");
emisor["RegimenFiscalE"] = "601";
emisor["RfcE"] = "EKU9003173C9";
emisor["NomDenRazSocE"] = "ESCUELA KEMPER URGATE";



//#NODO [conf]
MFObject conf = new MFObject("conf");
conf["pass"] = "12345678a";
conf["cer"] = "c:/sdk2/certificados/EKU9003173C9.cer.pem";
conf["key"] = "c:/sdk2/certificados/EKU9003173C9.key.pem";



//#NODO [PAC]
MFObject PAC = new MFObject("PAC");
PAC["usuario"] = "DEMO700101XXX";
PAC["pass"] = "DEMO700101XXX";
PAC["produccion"] = "NO";



//#NODO [totales]
MFObject totales = new MFObject("totales");
totales["MontoTotExent"] = "0.00";
totales["MontoTotRet"] = "580.00";
totales["MontoTotOperacion"] = "2000.00";
totales["MontoTotGrav"] = "2000.00";



//#NODO [totales/ImpRetenidos]
MFObject totales_ImpRetenidos = new MFObject("ImpRetenidos");



//#NODO [totales/ImpRetenidos/0]
MFObject totales_ImpRetenidos_0 = new MFObject("0");
totales_ImpRetenidos_0["ImpuestoRet"] = "001";
totales_ImpRetenidos_0["TipoPagoRet"] = "03";
totales_ImpRetenidos_0["MontoRet"] = "580.00";
totales_ImpRetenidos_0["BaseRet"] = "2000";
totales_ImpRetenidos.AgregaSubnodo(totales_ImpRetenidos_0);



//#NODO [factura]
MFObject factura = new MFObject("factura");
factura["CveRetenc"] = "01";
factura["FechaExp"] = "2025-02-19T15:56:14";
factura["FolioInt"] = "9";
factura["LugarExpRetenc"] = "45110";
factura["fecha_expedicion"] = "AUTO";



//#NODO [receptor]
MFObject receptor = new MFObject("receptor");
receptor["RegimenFiscalReceptor"] = "612";
receptor["DomicilioFiscalReceptor"] = "27054";
receptor["UsoCFDI"] = "G01";
receptor["nombre"] = "MIGUEL ANGEL SOSA HERNANDEZ";
receptor["NacionalidadR"] = "Nacional";
receptor["rfc"] = "SOHM7509289MA";



//#NODO [receptor/Nacional]
MFObject receptor_Nacional = new MFObject("Nacional");
receptor_Nacional["DomicilioFiscalR"] = "86991";
receptor_Nacional["NomDenRazSocR"] = "UNIVERSIDAD ROBOTICA ESPAÃOLA";
receptor_Nacional["RfcR"] = "URE180429TM6";


//#Agrega Nodos
sdk.AgregaObjeto(PAC);
sdk.AgregaObjeto(conf);
sdk.AgregaObjeto(factura);
sdk.AgregaObjeto(emisor);
receptor.AgregaSubnodo(receptor_Nacional);
sdk.AgregaObjeto(receptor);
sdk.AgregaObjeto(periodo);
totales.AgregaSubnodo(totales_ImpRetenidos);
sdk.AgregaObjeto(totales);
Pagosaextranjeros.AgregaSubnodo(Pagosaextranjeros_NoBeneficiario);
Pagosaextranjeros.AgregaSubnodo(Pagosaextranjeros_Beneficiario);
sdk.AgregaObjeto(Pagosaextranjeros);

	
//#Ejecuta KIT
SDKRespuesta respuesta = sdk.Timbrar(@"C:\sdk2\timbrar32.bat", @"C:\sdk2\timbrados\", "factura", false);
//Muestra el archivo ini
//textBox1.Text = sdk.Ini;
//Muestra la respuesta de timbrado
//textBox2.Text = respuesta.RespuestaOriginalSDK;
// Se notifica que el SDK se ejecutó
string mensaje = string.Format("Código: {0}\r\nMensaje: {1}", respuesta.Codigo_MF_Numero, respuesta.Codigo_MF_Texto);
MessageBox.Show(this, mensaje, Application.ProductName, MessageBoxButtons.OK, respuesta.Codigo_MF_Numero == "0" ? MessageBoxIcon.Information : MessageBoxIcon.Warning);
			
	



            /////////////////////////////////////////////////////
            ///


        }
    }
}
